<?php

// Require json support
$dir = rtrim(dirname(__FILE__), '/').'/';
include_once($dir.'wfmjson.php');
	
	if (!function_exists('get_contents'))
	{
		function get_contents($url)
		{			
			// We are going to use curl to grab the url
			$ch = curl_init();
			$timeout = 5;
			curl_setopt($ch, CURLOPT_URL, $url);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, $timeout);
			$data = curl_exec($ch);
			curl_close($ch);
			
			return $data !== false ? $data : @file_get_contents($url);
		}
	}

// Only define the function if it doesn't already exist
if (!function_exists('wpflickr')) {

	function wpflickr($photoset = '', $size = 'url_m') {
		// The params for the request
		$params  = array(
			'api_key'	=> 'bebf1bb4242efc58da3655c2c77f022d',
			'method'	=> 'flickr.photosets.getPhotos',
			'photoset_id'	=> $photoset,
			'extras' => 'description,url_t,'.$size,
			'format'	=> 'php_serial',
		);
		
		// The url encoded params
		$encoded_params = array();
		foreach ($params as $k => $v){
			$encoded_params[] = urlencode($k).'='.urlencode($v);
		}
		
		// Construct the url
		$url = 'http://api.flickr.com/services/rest/?'.implode('&', $encoded_params);
		
		// We are going to use curl to grab the url
		$data = get_contents($url);

		// The response array
		$rsp_obj = unserialize($data);
		
		// Generate the hash
		$flickr = array();

		if ($rsp_obj['stat'] == 'ok'){
		
			// Get the photoset
			$photoset = $rsp_obj['photoset'];
			$photos = $photoset['photo'];
			
			// For each photo
			foreach($photos as $photo) {
				
				// Get the description
				$desc = $photo['description']['_content'];
				
				// Get the source
				$src = $photo[$size];
				$t = $photo['url_t'];
				
				$flickr[(string)$src] = array('caption' => (string)$desc, 'thumbnail' => (string)$t, 'href' => (string)$src);
				//error_log('src: '.$src.' caption: '.$desc.' thumbnail: '.$src.' href: '.$href);
			}
		}
		
		// Return a json encoded string
		/*return json_encode($flickr);*/
		return $flickr;
	}
}

if (!function_exists('getClosestValue'))
{
	// http://stackoverflow.com/questions/5464919/php-nearest-value-from-an-array
	function getClosestValue($search, $arr)
	{
	   $closest = null;
	   foreach($arr as $item)
	   {
	      if($closest == null || abs($search - $closest) > abs($item - $search))
	      {
	         $closest = $item;
	      }
	   }
	   return $closest;
	}
}
?>