<?php

// Require json support
$dir = rtrim(dirname(__FILE__), '/').'/';
require_once($dir.'wfmjson.php');
require_once($dir.'Cache.php');
require_once($dir.'Picasa.php');
require_once($dir.'Album.php');

// Only define the function if it doesn't already exist
if (!function_exists('wppicasa')) {

	function wppicasa($username = '', $collection = '', $thumbnailSize = false) {

		// Generate the hash
		$picasa = array();
		
		// Thumbnails
		$sizes = array(32, 48, 64, 72, 144, 160, 200, 288, 320, 400, 512, 576, 640, 720, 800);

		// Query the data for all image elements
		error_reporting(0);
		
		try {
			$p = new Picasa();
			$size = getClosestValue($thumbnailSize, $sizes);
			$album = $p->getAlbumById($username, $collection, $maxResults=null, $startIndex=null, $keywords=null, $tags=null, $size);
		
			$images = $album->getImages();

			// Loop over each image
			foreach ($images as $image) {

				// Get the description to use as a caption
				$desc = $image->getDescription();

				// Get the direct url
				$src = $image->getContent();
			
				// Get the medium thumbnail
				$thumbnails = $image->getThumbnails();
				$thumbnail = '';
				foreach ($thumbnails as $t)
				{
					if ($t->getHeight() == $size || $t->getWidth() == $size)
						$thumbnail = $t->getUrl();
				}
			
				$picasa[(string)$src] = array('caption' => (string)$desc, 'thumbnail' => (string)$thumbnail, 'href' => (string)$src);
				//error_log('src: '.$src.' caption: '.$desc.' thumbnail: '.$src.' href: '.$src);
			}
		} catch (Exception $e)
		{
			
		}
		
		// Return a json encoded string
		/*return json_encode($picasa);*/
		return $picasa;
	}
}

if (!function_exists('getClosestValue'))
{
	// http://stackoverflow.com/questions/5464919/php-nearest-value-from-an-array
	function getClosestValue($search, $arr)
	{
	   $closest = null;
	   foreach($arr as $item)
	   {
	      if($closest == null || abs($search - $closest) > abs($item - $search))
	      {
	         $closest = $item;
	      }
	   }
	   return $closest;
	}
}

?>