<?php

// Require json support
include_once('wfmjson.php');
	
	if (!function_exists('get_contents'))
	{
		function get_contents($url)
		{			
			// We are going to use curl to grab the url
			$ch = curl_init();
			$timeout = 5;
			curl_setopt($ch, CURLOPT_URL, $url);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, $timeout);
			$data = curl_exec($ch);
			curl_close($ch);
			
			return $data !== false ? $data : @file_get_contents($url);
		}
	}

// Only define the function if it doesn't already exist
if (!function_exists('wpember')) {

	function wpember($username = '', $collection = '') {
		// Construct the url
		$url = 'http://api.emberapp.com/users/view/'.urlencode($username).'/collections/view/'.urlencode($collection).'/';
		
		// We are going to use curl to grab the url
		$data = get_contents($url);

		// Generate the hash
		$ember = array();

		// Query the data for all image elements
		$xml = new SimpleXMLElement($data);
		$images = $xml->xpath('images/image');

		// Loop over each image
		foreach ($images as $image) {
			$file = $image->xpath('file');
			$file = $file[0];

			$desc = $image->xpath('description');
			$desc = $desc[0];

			$src = $file->xpath('src');
			$src = $src[0];
			
			$ext = @pathinfo($src, PATHINFO_EXTENSION);
			$elements = @explode('/', $src);
			@array_pop($elements);
			$thumb = @trim(@implode('/', $elements), '/').'/t.'.$ext;

			$ember[(string)$src] = array('caption' => (string)$desc, 'thumbnail' => (string)$thumb, 'href' => (string)$src);
			//error_log('src: '.$src.' caption: '.$desc.' thumbnail: '.$src.' href: '.$href);
		}
		
		// Return a json encoded string
		/*return json_encode($ember);*/
		return $ember;
	}
}

if (!function_exists('getClosestValue'))
{
	// http://stackoverflow.com/questions/5464919/php-nearest-value-from-an-array
	function getClosestValue($search, $arr)
	{
	   $closest = null;
	   foreach($arr as $item)
	   {
	      if($closest == null || abs($search - $closest) > abs($item - $search))
	      {
	         $closest = $item;
	      }
	   }
	   return $closest;
	}
}
?>